<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               ref="crud"
               v-model="form"
               :permission="permissionList"
               :before-open="beforeOpen"
               :before-close="beforeClose"
               @row-del="rowDel"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad"
               @tree-load="treeLoad"
               :uploadExceed="uploadExceed"
               :upload-preview="uploadPreview"
               @cell-click="clickCell"
               >
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   v-if="permission.menu_delete"
                   plain
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot-scope="scope" slot="menu">
        <el-button
          type="text"
          icon="el-icon-circle-plus-outline"
          size="small"
          @click.stop="handleAdd(scope.row,scope.index)"
          v-if="userInfo.role_name.includes('admin') && scope.row.category === 1"
        >新增子项
        </el-button>
        <el-button type="text" size="small" @click.stop="handleCopyAdd(scope.row,scope.index)"
          v-if="userInfo.role_name.includes('admin') && scope.row.category === 1"
        >复制菜单</el-button>

<!--        <el-button
          type="text"
          icon="el-icon-circle-plus-outline"
          size="small"
          @click.stop="handleTYAdd(scope.row,scope.index)"
        >添加提示语
        </el-button>-->
      </template>
      <template slot-scope="{row}"
                slot="source">
        <div style="text-align:center">
          <i :class="row.source"/>
        </div>
      </template>
       <template slot="excelUrl" slot-scope="scope" >
         <el-link>
           <avue-text-ellipsis :text="scope.row.excelUrl" :height="100">
              <small slot="more">...</small>
            </avue-text-ellipsis>
         </el-link>

      </template>

    </avue-crud>
      <!-- PDF预览 -->
      <el-dialog title="文件预览" :visible.sync="dialogVisible4" width="70%" append-to-body center>
          <iframe :src="pdfSrc" frameborder="0" style="width: 100%; height: 500px"></iframe>
      </el-dialog>
  </basic-container>
</template>

<script>
  import {getLazyList, remove, update, add, getMenu} from "@/api/system/menu";
  import {mapGetters} from "vuex";
  import iconList from "@/config/iconList";
  import func from "@/util/func";
  import {getMenuTree} from "@/api/system/menu";

  export default {
    data() {
      return {
        dialogVisible4:false,//pdf预览
        pdfSrc:'',
        form: {},
        query: {},
        loading: true,
        selectionList: [],
        parentId: 0,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0,
        },
        option: {
          lazy: true,
          tip: false,
          simplePage: true,
          searchShow: true,
          searchMenuSpan: 6,
          dialogWidth: "60%",
          tree: true,
          border: true,
          index: true,
          selection: true,
          viewBtn: true,
          menuWidth: 400,
          dialogClickModal: false,
          column: [
            {
              label: "菜单名称",
              prop: "name",
              search: true,
              rules: [
                {
                  required: true,
                  message: "请输入菜单名称",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "所属系统",
              type: "select",
              dicUrl: "/api/blade-system/client/getClinetAll",
              props: {
                label: "clientId",
                value: "id"
              },
              slot: true,
              prop: "sysId",
              search: true,
            },
            {
              label: "路由地址",
              prop: "path",
              rules: [
                {
                  required: true,
                  message: "请输入路由地址",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "上级菜单",
              prop: "parentId",
              type: "tree",
              dicData: [],
              hide: true,
              addDisabled: false,
              props: {
                label: "title"
              },
              rules: [
                {
                  required: false,
                  message: "请选择上级菜单",
                  trigger: "click"
                }
              ]
            },
            {
              label: "菜单图标",
              prop: "source",
              type: "icon",
              slot: true,
              iconList: iconList,
              hide: true,
            },
            {
              label: "菜单编号",
              prop: "code",
              rules: [
                {
                  required: true,
                  message: "请输入菜单编号",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "客户端图标",
              prop: "source",
              hide: true,
            },
            {
              label: "菜单别名",
              prop: "alias",
              hide: true,
              rules: [
                {
                  required: true,
                  message: "请输入菜单别名",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "菜单类型",
              prop: "category",
              type: "radio",
              dicData: [
                {
                  label: "菜单",
                  value: 1
                },
                {
                  label: "按钮",
                  value: 2
                }
              ],
              value: 1,
              rules: [
                {
                  required: true,
                  message: "请选择菜单类型",
                  trigger: "blur"
                }
              ],
            },
            {
              label: "新窗口",
              prop: "isOpen",
              type: "radio",
              disabled: false,
              hide: true,
              dicData: [
                {
                  label: "否",
                  value: 1
                },
                {
                  label: "是",
                  value: 2
                }
              ],
              value: 1,
              rules: [
                {
                  required: true,
                  message: "请选择新窗口打开",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "是否外层",
              prop: "isLayout",
              type: "radio",
              disabled: false,
              hide: true,
              dicData: [
                {
                  label: "否",
                  value: 1
                },
                {
                  label: "是",
                  value: 2
                }
              ],
              value: 1,
              rules: [
                {
                  required: true,
                  message: "请选择新窗口打开",
                  trigger: "blur"
                }
              ]
            },
                {
              label: "是否显示按钮",
              prop: "isShowButton",
              type: "radio",
              disabled: false,
                  hide: true,
              dicData: [
                {
                  label: "是",
                  value: 1
                },
                {
                  label: "否",
                  value: 2
                }
              ],
              value: 1,
              rules: [
                {
                  required: true,
                  message: "请选择新窗口打开",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "菜单排序",
              prop: "sort",
              type: "number",
              row: true,
              span: 24,
              value: 1,
              rules: [
                {
                  required: true,
                  message: "请输入菜单排序",
                  trigger: "blur"
                }
              ]
            },
            {
              label: "菜单备注",
              prop: "remark",
              type: "textarea",
              span: 24,
              minRows: 2,
              hide: true
            },
            {
              label: "提示语",
              prop: "textInfo",
              type: "textarea",
              span: 24,
              minRows: 2,
              hide: true,
            },
            {
              label: '菜单视频',
              prop: 'videoUrl',
              type: 'upload',
              listType: 'picture-img',
              span: 12,
              hide: true,
              accept:"video/mp4",
              propsHttp: {
                url:'data'
              },
              limit:1,
              tip: '只能上传MP4格式，且不能用QQ录屏，推荐使用win10自带录屏录制，文件大小限制50兆',
                // tip: '只能上传jpg/png用户头像，且不超过500kb',
              action: "/api/blade-resource/oss/endpoint/put-file2"
            },
            {
              label: '文档信息',
              prop: 'excelUrl',
              type: 'upload',
              span: 12,
              hide: true,
              multiple:false,
              dataType: "string",
              loadText: '模板上传中，请稍等',
              propsHttp: {
                url:'data',

              },

              limit:1,
              tip: '上传文档说明',
              action: "/api/blade-resource/oss/endpoint/upload-file2"
            },
            // {
            //   label: "文档信息",
            //   prop: "excelUrl",
            //   type: "url",
            //   span: 24,
            //   minRows: 2,
            //   propsHttp: {
            //     url:'data'
            //   }

            // },
          ]
        },
        data: []
      };
    },
    watch: {
      'form.category'() {
        const category = func.toInt(this.form.category);
        this.$refs.crud.option.column.filter(item => {
          if (item.prop === "path") {
            item.rules[0].required = category === 1;
          }
          if (item.prop === 'isOpen') {
            item.disabled = category === 2;
          }
          if (item.prop === 'textInfo' ) {
            if(category===1){
              item.disabled = true;
            }
            if(category===2){
              item.disabled = false;
            }

          }
          if (item.prop === 'videoUrl') {
            if(category===1){
              item.disabled = false;
            }
            if(category===2){
              item.disabled = true;
            }
          }

        });
      },
    },
    computed: {
      ...mapGetters(["userInfo", "permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.menu_add, false),
          viewBtn: this.vaildData(this.permission.menu_view, false),
          delBtn: this.vaildData(this.permission.menu_delete, false),
          editBtn: this.vaildData(this.permission.menu_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      uploadExceed(limit, files, fileList, column){
        this.$message.warning('只允许上传1个文件，请先删除原文件再次点击上传')
      },
        //上传后进行点击预览
      uploadPreview(file, column, done) {
          this.dialogVisible4=true;
          this.pdfSrc=file.url


      },
    // 点击第文档信息列的单元格
    clickCell(row, column, cell, event) {
      if (column.label === "文档信息") {
        this.dialogVisible4=true;
        this.pdfSrc=row.excelUrl
      }
    },
      initData() {
        getMenuTree().then(res => {
          const column = this.findObject(this.option.column, "parentId");
          column.dicData = res.data.data;
        });
      },
      handleAdd(row) {
        this.parentId = row.id;
        const column = this.option.column
        //所属系统
        const findSys = this.findObject(column, "sysId");
        findSys.value = row.sysId;

        //上级菜单
        const findParent = this.findObject(column, "parentId");
        findParent.value = row.id;
        findParent.addDisabled = true;

        //路由地址
        const findPath = this.findObject(column, "path");
        findPath.value = row.path;

        //菜单编号
        const findCode = this.findObject(column, "code");
        findCode.value = row.code;

        //菜单别名
        const findAlias = this.findObject(column, "alias");
        findAlias.value = row.alias;

        //菜单图标
        const findSource = this.findObject(column, "source");
        findSource.value = '';

        //菜单排序
        const findSort = this.findObject(column, "sort");
        findSort.value = 1;

        //执行新增
        this.$refs.crud.rowAdd();
      },
      handleCopyAdd(row) {
        this.parentId = row.parentId;
        const column = this.option.column
        //所属系统
        const findSys = this.findObject(column, "sysId");
        findSys.value = row.sysId;

        //上级菜单
        const findParent = this.findObject(column, "parentId");
        findParent.value = row.parentId;

        //路由地址
        const findPath = this.findObject(column, "path");
        findPath.value = row.path;

        //菜单编号
        const findCode = this.findObject(column, "code");
        findCode.value = row.code;

        //菜单别名
        const findAlias = this.findObject(column, "alias");
        findAlias.value = row.alias;

        //菜单图标
        const findSource = this.findObject(column, "source");
        findSource.value = row.source;

        //菜单排序
        const findSort = this.findObject(column, "sort");
        findSort.value = Number(row.sort) + 1;

        //执行新增
        this.$refs.crud.rowAdd();
      },

      // 提示语
   /*   handleTYAdd(row) {
        this.parentId = row.id;
        const column = this.findObject(this.option.column, "parentId");
        column.value = row.id;
        column.addDisabled = true;
        this.$refs.crud.rowAdd();
      },*/
      rowSave(row, done, loading) {
        add(row).then((res) => {
          // 获取新增数据的相关字段
          const data = res.data.data;
          row.id = data.id;
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          // 数据回调进行刷新
          done(row);
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          // 数据回调进行刷新
          done(row);
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      rowDel(row, index, done) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            // 数据回调进行刷新
            done(row);
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            // 刷新表格数据并重载
            this.data = [];
            this.parentId = 0;
            this.$refs.crud.refreshTable();
            this.$refs.crud.toggleSelection();
            // 表格数据重载
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      searchReset() {
        this.query = {};
        this.parentId = 0;
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.parentId = '';
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      beforeOpen(done, type) {
        if (["add", "edit"].includes(type)) {
          this.initData();
        }
        if (["edit", "view"].includes(type)) {
          getMenu(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      beforeClose(done) {
        this.parentId = "";
        const column = this.findObject(this.option.column, "parentId");
        column.value = "";
        column.addDisabled = false;
        done();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getLazyList(this.parentId, Object.assign(params, this.query)).then(res => {
          this.data = res.data.data;
          this.loading = false;
          this.selectionClear();
        });
      },
      treeLoad(tree, treeNode, resolve) {
        const parentId = tree.id;
        getLazyList(parentId).then(res => {
          resolve(res.data.data);
        });
      }
    }
  };
</script>

<style>
</style>
